//#define DEBUG_OFF // defining this hacks out all use and code for debug library.

#define SERIAL_tt Serial // Send debug_tt output here. Must have SERIAL_tt.begin( ## )
#include "debug_tt.h"
// For haltif() entering 'd' calls this optional code
// It can call functions or dump globals.
void Debug_Dump(void)
{
  where_tt( );
  printf_tt(" User Custom Debug Dump. Micros==%u", micros());
  // Put code here to call after Fault or HaltIf() - or call it in sketch
  return;
}


#define BUTTON_ISR 7
void setup() {
  Serial.begin(115200);
  while (!Serial && millis() < 5000 );
  SERIAL_tt.begin( 1843200 ); //  SERIAL_tt.begin( 115200 );
  SERIAL_tt.println("\n" __FILE__ " " __DATE__ " " __TIME__);
  SERIAL_tt.println("\n********\n T4 connected Serial_tt ******* debug_tt port\n");
  pinMode( BUTTON_ISR, INPUT_PULLUP );
  Serial.println("\n" __FILE__ " " __DATE__ " " __TIME__);
  debBegin_tt( (HardwareSerial*)&SERIAL_tt, LED_BUILTIN, BUTTON_ISR);
  Serial.println("\n begin ...");
  deb_tt( 2, micros() );

  // Sample prints through the debug_tt code printf
  printf_tt( "TESTING 1 2 3 ...456... %s\n", "xyz" );
  printf_tt( "%u\t", 123456 );
  printf_tt( "TESTING ABC.\n" );

  deb_tt( 2, micros() );
  deb_tt( 3, micros() );
  deb_tt( 4, micros() );
  deb_tt( 401, 0 );
  addr_tt( setup );
  int ii;
  addr_tt( &ii );
  for ( ii = 0; ii < 50; ii++ )
  {
    deb_tt( 5, micros() );
    deb_tt( 6, micros() );
    deb_tt( 7, ii );
    delayMicroseconds( 1 );
  }
  deb_tt( 401, 0 );
  debText_tt( __func__ ); // show function entry
  assert_tt( 0 * micros() );
}

void loop() {
  static uint16_t ii = 0;
  deb_tt( ii, micros() );
  haltif_tt( !digitalReadFast( BUTTON_ISR ) ); // Stop on button press
  ii++;
  ii &= 7;
  delay(2000);
  // Serial1.println("\n NOW FAULT ...");
#if defined(__IMXRT1062__)
  // GPT1_CNT = 5; // FAULT
#endif
  assert_tt( ii%3 );
}
