//#define DEBUG_OFF // defining this hacks out all use and code for debug library.

#define SERIAL_tt Serial // Send debug_tt output here. Must have SERIAL_tt.begin( ## )
#ifdef DEBUG_OFF_XXX
//#define debState( a ) 0
#define debText_tt( a )
#define deb_tt( a, b )
#define haltif_tt( a )
#define assert_tt( a ) // if (!a) { assert_3(__FILE__, __LINE__,  #a, __func__); }
#define qBlink() digitalWriteFast( LED_BUILTIN, !digitalReadFast( LED_BUILTIN ) )

//
#define debSet( a,b,c,d )

#define debText_tt( a )
#define debText_tt2( a, b )

#define debug_fault( a )

#define assert_3( a,b,c,d )
#define debugWait( a )

#else
#endif
#include "debug_tt.h"
// For haltif() entering 'd' calls this optional code
// It can call functions or dump globals.
void Debug_Dump(void)
{
  where_tt( );
  //printf(" User Custom Debug Dump. Micros==%u", micros());
  printf_tt(" User Custom Debug Dump. Micros==%u", micros());
  // Put code here to call after Fault or HaltIf() - or call it in sketch
  return;
}


#define BUTTON_ISR 3
// void yield() {}
void setup() {
  SERIAL_tt.begin( 1843200 ); //  SERIAL_tt.begin( 115200 );
  // debugprint.c :: LPUART3_BAUD = LPUART_BAUD_OSR(12) | LPUART_BAUD_SBR(1); // 1843200 baud
  //Serial4.begin( 1843200 );   //  Serial4.begin( 115200 ); //
  SERIAL_tt.println("\n" __FILE__ " " __DATE__ " " __TIME__);
  SERIAL_tt.println("\n********\n T4 connected Serial_1 *******  ONE\n");
  //Serial4.println("\n" __FILE__ " " __DATE__ " " __TIME__);
  //Serial4.println("\n********\n T4 connected Serial_4 *******  FOUR\n");
  Serial.begin(115200);
  while (!Serial && millis() < 5000 );
  pinMode( BUTTON_ISR, INPUT_PULLUP );
  Serial.println("\n" __FILE__ " " __DATE__ " " __TIME__);
  debBegin_tt( (HardwareSerial*)&SERIAL_tt, LED_BUILTIN, 12);
  //debBegin_tt( (HardwareSerial*)&Serial, LED_BUILTIN, 12);
  Serial.println("\n begin ...");
//return;
  // Serial.println("\tSHOULD END WITH >> Setup DONE! All Good?");
  deb_tt( 2, micros() );
#if defined(__IMXRT1062__)
  GPT1_CNT = 5; // FAULT
#endif
  foo();
  where_tt( );

  // Sample prints through the debug_tt code printf
  printf_tt( "TESTING 1 2 3 ...456... %s\n", "xyz" );
  printf_tt( "%u\t", 123456 );
  printf_tt( "TESTING ABC.\n" );

  deb_tt( 2, micros() );
  deb_tt( 3, micros() );
  deb_tt( 4, micros() );
  deb_tt( 401, 0 );
  assert_tt( 100 - 98 - 2 );
  addr_tt( setup );
  int ii;
  addr_tt( &ii );
  DebugTest2();
  SERIAL_tt.flush();
  while ( 1 ) {
    SERIAL_tt.flush();
    for ( ii = 0; ii < 50; ii++ )
    {
      micros();
      delayMicroseconds( 1 );
    }
    debText_tt( __func__ ); // show function entry
    debText_tt( __func__ ); // show function entry
    assert_tt( 0 * micros() );
  }
}

void foo( void ) {
  //SERIAL_tt.flush();
  where_tt( );
  // test
  addr_tt( foo );
  int ii;
  addr_tt( &ii );
  int jj;
  addr_tt( &jj );


  // Code Here
}


FASTRUN void DebugTest2() {
  SERIAL_tt.flush();
  debText_tt( __func__ ); // show function entry
  SERIAL_tt.flush();
  deb_tt( 2, micros() );
  float x = log (0);
  haltif_tt( isfinite( x ) ); // Halt if float not NAN or INF
  deb_tt( 3, 0x101101 );
  Serial.printf("INF >> %f\n", x); // Hard Fault with printf()
  deb_tt( 6, 0xdeadbeef );
  x = 0.0 / 0.0;
  deb_tt( 100, 0x111011 );
  assert_tt( !isinf( x ) ); // Testing here - passes isinf()
  Serial.printf("NAN >> %f\n", x); // Hard Fault with printf()
  deb_tt( 7, __LINE__ );
  printf("NAN >> %f\n", x); // Hard Fault with printf()
  deb_tt( 8, __LINE__ );
  debText_tt( __func__ ); // show function entry

  deb_tt( 9, __LINE__ );
  return;
#ifndef __Teensy4__
  if ( UART2_C2 ) deb_tt( 9, __LINE__ );  // UART2 not initialized, accessing this register causes a Hard Fault
#else
#endif
}

void loop() {
  static uint16_t ii = 0;
  SERIAL_tt.flush();
  deb_tt( ii, micros() );
  SERIAL_tt.flush();
  haltif_tt( digitalReadFast( BUTTON_ISR ) ); // Stop on button press
  ii++;
  ii &= 7;
  delay(2000);
  qBlink();
  // Serial1.println("\n NOW FAULT ...");
#if defined(__TEENSY4__)
  GPT1_CNT = 5; // FAULT
#endif
  assert_tt( 0 );
}
